package Generics;

import java.util.ArrayList;
import java.util.Iterator;

public class SetGeneric<T extends Object> {

    // список объектов
    private ArrayList<T> _places;
    // кол-во объектов
    private int maxCount;
    public int Count()
    {
        return _places.size();
    };

    public SetGeneric(int count)
    {
        _places = new ArrayList<>(count);
        maxCount = count;
    }

    // Добавление объекта в набор
    public int Insert(T airbus)
    {
        return Insert(airbus, 0);
    }

    // Добавление объекта в набор на конкретную позицию
    public int Insert(T airbus, int position)
    {
        if (position < 0 || position >= maxCount || Count() >= maxCount)
        {
            return -1;
        }
        _places.add(position, airbus);
        return position;
    }

    // Удаление объекта из набора с конкретной позиции
    public boolean Remove(int position)
    {
        if (position < 0 || position >= Count())
        {
            return false;
        }
        _places.remove(position);
        return true;
    }

    // Получение объекта из набора по позиции
    public T Get(int position)
    {
        if (position < 0 || position >= Count())
        {
            return null;
        }
        return _places.get(position);
    }

    public ArrayList<T> GetAirbus()
    {
        return _places;
    }
}
